'##################################################################################################
'Skrivet av: Carl Husberg (carl.husberg@gmail.com)

'Kllhnvisning
'Trdhantering - BlitzMax/Threads.bmx & BlitzMax/Threads 2.bmx (Kollat p trdhanteringen p dessa tv)
'HTTP Headers - http://en.wikipedia.org/wiki/List_of_HTTP_header_fields

'##################################################################################################
SuperStrict

'##################################################################################################
Framework BRL.System
Import BRL.SocketStream
Import BRL.LinkedList
Import BRL.Threads
Import BRL.StandardIO
Import BRL.Retro
Import BaH.FMODAudio

'##################################################################################################
Include "cWebServer\cWebServer.bmx"

Include "Source\TMusicPlayer.bmx"

'##################################################################################################
Type TApp
	
	Function Log:Int( Str:String )
		Print Str
	End Function
	
End Type

TWebServer.LogFunction = TApp.Log
TSession.LogFunction = TApp.Log
TConnection.LogFunction = TApp.Log

'##################################################################################################
TApp.Log( "cWebMP3Player" )
TApp.Log( "Created by: Carl Husberg (carl.husberg@gmail.com)" )
TApp.Log( "" )

SeedRnd( MilliSecs() )
TMusicPlayer.Init()

'##################################################################################################
Global Server:TWebServer = TWebServer.Create( 80, Temp )

Function Temp:Int( S:TSession )
	
	If( Lower( S.GetHeader( "method" ) ) = "get" )
		Local URL:String = S.GetHeader( "URL" )
		If( URL = "/" ) Then URL = "/index.html"
		print_page( S )
		
	ElseIf( Lower( S.GetHeader( "method" ) ) = "post" )
		
		Select( Lower( S.GetPost( "form_name" ) ) )
			Case "play"
				S.Log( "Play()" )
				TMusicPlayer.Play()
				
			Case "pause"
				S.Log( "Pause()" )
				TMusicPlayer.Pause()
			
			Case "changesong"
				Local NewSong:TSong = TMusicPlayer.GetSongFromID( Int( S.GetPost( "song_id" ) ) )
				TMusicPlayer.SetSong( NewSong )
				TMusicPlayer.Play()
				S.Log( "NewSong( '"+NewSong.Name+"' )" )
				
		End Select
				
		print_page( S )
		
	EndIf
	
End Function

Function print_page( S:TSession )
	S.SendLine( "<html>" )
	S.SendLine( "<head><title>cWebMP3Player</title></head>" )
	S.SendLine( "<body>" )
	S.SendLine( "<center>" )
	
	If( TMusicPlayer.CurSong <> Null )
		S.SendLine( "<h2 style='font-family: Arial; display:inline;'>Currently Playing: " + TMusicPlayer.CurSong.Name + "</h2>" )
		S.SendLine( "<br />" )
	EndIf
	
	S.SendLine( "<form style='display:inline;' Method='post' enctype='text/plain'>" )
	S.SendLine( "<input type='hidden' name='form_name' value='play' />" )
	S.SendLine( "<input type='submit' value='Play' />" )
	S.SendLine( "</form>" )
	S.SendLine( "<form style='display:inline;' method='post' enctype='text/plain'>" )
	S.SendLine( "<input type='hidden' name='form_name' value='pause' />" )
	S.SendLine( "<input type='submit' value='Pause' />" )
	S.SendLine( "</form>" )
	S.SendLine( "<br />" )
	S.SendLine( "<br />" )
	S.SendLine( "<div>" )
	S.SendLine( "<h3 style='display:inline; font-family:Arial;'>Tracklist</h3>" )
	S.SendLine( "<br />" )
	
	For Local A:TSong= EachIn TMusicPlayer.TrackList
		S.SendLine( "<form style='display:inline;' method='post' enctype='text/plain'>" )
		S.SendLine( "<input type='hidden' name='form_name' value='changesong' />" )
		S.SendLine( "<input type='hidden' name='song_id' value='"+A.ID+"' />" )
		S.SendLine( "<input type='submit' value='"+A.Name+"' />" )
		S.SendLine( "</form>" )
		S.SendLine( "<br />" )
	Next
	
	S.SendLine( "</div>" )
	S.SendLine( "</center>" )
	S.SendLine( "</body>" )
	S.SendLine( "</html>" )
End Function

'##################################################################################################
Repeat
	
	Server.Update()
	
Forever

'##################################################################################################