Const MPLAYER_STOPPED:Int	= 0
Const MPLAYER_PLAYING:Int	= 1
Const MPLAYER_PAUSED:Int	= 2

Type TSong
	
	Global ID_AI:Int = 1
	
	Field ID:Int
	Field Path:String
	Field Name:String
	
	Function Create:TSong( Path:String )
		Local A:TSong = New TSong
		A.GenerateID()
		A.Path = Path
		A.Name = StripAll( A.Path )
		Return( A )
	End Function
	
	Method GenerateID()
		ID = ID_AI
		ID_AI = ID_AI + 1
	End Method
	
End Type

Type TMusicPlayer
	
	Global Channel:TChannel
	Global Sound:TSound
	Global CurSong:TSong
	
	Global TrackList:TList = CreateList()
	Global Status:Int
	
	Function Init()
		SetAudioDriver("FMOD")
		ReadDirectory()
		Channel = AllocChannel()
	End Function
	
	Function ReadDirectory()
		Local Path:String = "mp3\"
		
		Local Dir:String[] = LoadDir( Path )
		For Local File:String = EachIn Dir
			If Lower( ExtractExt( File ) ) = "mp3"
				ListAddLast( TrackList, TSong.Create( Path + File ) )
			EndIf
		Next
	End Function
	
	Function GetSongFromID:TSong( SongID:Int )
		For Local A:TSong = EachIn TrackList
			If A.ID = SongID
				Return A
			EndIf
		Next
	End Function
	
	Function SetSong( Song:TSong )
		CurSong = Song
		Sound = LoadSound( CurSong.Path )
		Channel = CueSound( Sound )
		Status = MPLAYER_STOPPED
	End Function
	
	Function Play()
		If( Status = MPLAYER_STOPPED Or Status = MPLAYER_PAUSED )
			ResumeChannel( Channel )
			Status = MPLAYER_PLAYING
		EndIf
	End Function
	
	Function Pause()
		If( Status = MPLAYER_PLAYING )
			PauseChannel( Channel )
			Status = MPLAYER_PAUSED
		EndIf
	End Function
	
End Type