'##################################################################################################
Type TSession  Extends TModule
	
	'################################################
	'File Send Buffer Size
	Global OPT_BUFFERSIZE:Int = 4096
	
	'################################################
	Field HeaderData:TList = CreateList()
	Field PostData:TList = CreateList()
	Field Connection:TConnection
	
	'################################################
	Method ReadIncData:Int()
		If( ReadHeader() )
			If( Lower( GetHeader( "method" ) ) = "post" )
				If( ReadPost() )
					Return True
				Else
					Return False
				EndIf
			EndIf
		Else
			Return False
		EndIf
		Return True
	End Method
	
	'################################################
	Method ReadHeader:Int()
		Try
			If( SocketConnected( Connection.Socket ) )
				Local Head:String = ReadLine( Connection.Stream )
				
				If( Head <> "" )
					Local HeadSplit:String[] = Head.Split( " " )
					ListAddLast( HeaderData, "Method: " + HeadSplit[0] )
					ListAddLast( HeaderData, "URL: " + HeadSplit[1] )
					ListAddLast( HeaderData, "Version: " + HeadSplit[2] )
					
					For Local I:Int = 0 To 99
						Local Line:String = ReadLine( Connection.Stream )
						If( Line <> "" )
							ListAddLast( HeaderData, Line )
						Else
							Exit
						EndIf
					Next
				Else
					Return False
				EndIf
			Else
				Return False
			EndIf
		Catch Read:TStreamReadException
			Return False
			
		EndTry
		
		Return True
	End Method
	
	'################################################
	Method ReadPost:Int()
		Try
			Local ContentLength:Int = Int( GetHeader( "content-length" ) )
			Local Data:String = ""
			
			For Local I:Int = 0 To ContentLength - 1
				Local B:Byte = ReadByte( Connection.Stream )
				Select B
					Case 10, 13, 38
						If Data <> ""
							ListAddLast( PostData, Data )
							Data = ""
						EndIf
					Default
						Data = Data + Chr( B )
				End Select
			Next
			If Data <> ""
				ListAddLast( PostData, Data )
			EndIf
		Catch Exception:TStreamReadException
			Return False
			
		EndTry
		Return True
	End Method
	
	'################################################
	Method GetHeader:String( Find:String )
		If HeaderData = Null Then Return ""
		If CountList( HeaderData ) = 0 Then Return ""
		
		For Local A:String = EachIn HeaderData
			If Lower( Find ) = Lower( Left( A, Instr( A, " " ) - 2 ) )
				Return Mid( A, Instr( A, " " ) + 1 )
			EndIf
		Next
	End Method
	
	'################################################
	Method GetPost:String( Find:String )
		For Local A:String = EachIn Self.PostData
			If Instr( A, "=" )
				If Lower( Left( A, Instr( A, "=" ) - 1 ) ) = Lower( Find )
					Return( Mid( A, Instr( A, "=" ) + 1 ) )
				EndIf
			EndIf
		Next
		Return ""
	End Method
	
	'################################################
	Method SendFile( Path:String )
	
		Local File:TStream = ReadFile( Path )
		Try
			CopyBytes( File, Connection.Stream, StreamSize( File ), OPT_BUFFERSIZE )
			CloseFile( File )
		Catch Write:TStreamWriteException
			CloseFile( File )
			Connection.Close()
		Catch Read:TStreamWriteException
			CloseFile( File )
			Connection.Close()
		EndTry
		
	End Method
	
	'################################################
	Method SendLine( Str:String )
		WriteLine( Connection.Stream, Replace( Str, "'", Chr(34) ) )
	End Method
	
	'################################################
End Type

'##################################################################################################
